/*******************************************************************************
  Main Source File

  Company:
    Microchip Technology Inc.

  File Name:
    main.c

  Summary:
    This file contains the "main" function for a project.

  Description:
    This file contains the "main" function for a project.  The
    "main" function calls the "SYS_Initialize" function to initialize the state
    machines of all modules in the system
 *******************************************************************************/

// *****************************************************************************
// *****************************************************************************
// Section: Included Files
// *****************************************************************************
// *****************************************************************************

#include <stddef.h>                     // Defines NULL
#include <stdbool.h>                    // Defines true
#include <stdlib.h>                     // Defines EXIT_FAILURE
#include "definitions.h"                // SYS function prototypes
#include <cp0defs.h>

#define     LCD_RST     GPIO_PIN_RB7      //RB7 //7
#define     D_LATCH     GPIO_PIN_RB7
#define     LCD_CS      GPIO_PIN_RB5      //RB5 //5
#define     W_AD_CLR    GPIO_PIN_RB5
#define     LCD_WR      GPIO_PIN_RB3      //RB3 //3
#define     LCD_DC      GPIO_PIN_RB6      //RB6 //6
#define     LCD_RD      GPIO_PIN_RB2      //RB2 //2
#define     WE          GPIO_PIN_RB9

#define     SW1         GPIO_PIN_RB10
#define     SW2         GPIO_PIN_RB11
#define     SW3         GPIO_PIN_RB12
#define     SW4         GPIO_PIN_RB13
#define     SW5         GPIO_PIN_RB14
#define     SW6         GPIO_PIN_RB15

#define     SOUND1      GPIO_PIN_RF0
#define     SOUND2      GPIO_PIN_RF1
#define     SOUND3      GPIO_PIN_RF2
#define     SOUND4      GPIO_PIN_RF3
#define     SOUNDF      GPIO_PIN_RF4

#define     I2C_EEPROM  0x50


//#define     KEY_NEXT_COUNT_INIT 10
#define     TIME_DOWN_INIT  150
#define     NEXT_COUNT_INIT 40

//#define     VGA_FLG         1       //VGA=1,LCD=0

// *****************************************************************************
// *****************************************************************************
// Section: Main Entry Point
// *****************************************************************************
// *****************************************************************************

//unsigned char   i2c_data;

unsigned char   mode;
unsigned char	sw1_key;
unsigned char	sw1_rep;
unsigned char	sw1_cnt;
unsigned char	sw2_key;
unsigned char	sw2_rep;
unsigned char	sw2_cnt;
unsigned char	sw3_key;
unsigned char	sw3_rep;
unsigned char	sw3_cnt;
unsigned char	sw4_key;
unsigned char	sw4_rep;
unsigned char	sw4_cnt;
unsigned char	sw5_key;
unsigned char	sw5_rep;
unsigned char	sw5_cnt;
unsigned char	sw6_key;
unsigned char	sw6_rep;
unsigned char	sw6_cnt;

//unsigned char   vga_flg;



unsigned char   vram[8192];








unsigned char color_data1[16]={0,248,7,0,255,248,7,255,127,120,7,251,248,3,123,1};
unsigned char color_data2[16]={0,0,224,31,224,31,255,255,224,31,239,224,15,255,239,224};

const unsigned char   game_moji_font[100][8]={
//
    {254,198,198,198,198,198,254,0},{56,120,24,24,24,24,126,0},{254,198,6,254,192,192,254,0},{254,198,6,30,6,198,254,0},{198,198,198,254,6,6,6,0},
    {254,192,192,254,6,198,254,0},{254,198,192,254,198,198,254,0},{254,198,198,6,6,6,6,0},{254,198,198,254,198,198,254,0},{254,198,198,254,6,6,254,0},
    {124,198,198,254,198,198,198,0},{252,198,198,254,198,198,252,0},{124,198,192,192,192,198,124,0},{252,198,198,198,198,198,252,0},{254,192,192,252,192,192,254,0},
    {254,192,192,252,192,192,192,0},{124,198,192,204,198,198,124,0},{198,198,198,254,198,198,198,0},{60,24,24,24,24,24,60,0},{6,6,6,198,198,198,124,0},
    {198,206,220,248,220,206,198,0},{192,192,192,192,192,192,254,0},{198,238,254,214,198,198,198,0},{198,230,246,254,222,206,198,0},{124,198,198,198,198,198,124,0},
    {252,198,198,252,192,192,192,0},{124,198,198,198,222,198,124,0},{252,198,198,254,204,206,198,0},{124,198,192,254,6,198,124,0},{126,24,24,24,24,24,24,0},
    {198,198,198,198,198,198,124,0},{198,198,198,198,108,56,16,0},{198,198,214,214,254,238,68,0},{198,238,124,56,124,238,198,0},{102,102,102,60,24,24,24,0},
    {254,6,12,56,96,192,254,0},{0,0,0,56,0,0,0,0},{0,0,0,0,0,0,0,0},{0,0,0,0,0,24,24,0},{0,0,124,198,198,198,124,0},
    {126,2,2,20,24,16,32,0},{2,4,8,24,40,72,8,0},{8,126,66,66,2,4,56,0},{0,62,8,8,8,8,62,0},{8,126,8,24,40,72,8,0},
    {16,126,18,18,18,18,36,0},{8,62,8,62,8,8,8,0},{30,34,66,4,8,16,96,0},{32,62,72,8,8,8,16,0},{0,126,2,2,2,2,126,0},
    {36,126,36,36,4,8,16,0},{0,112,0,114,2,4,120,0},{126,2,4,8,24,36,66,0},{32,126,34,36,32,32,30,0},{66,66,34,2,4,8,48,0},
    {30,34,98,20,8,16,96,0},{4,56,8,126,8,8,112,0},{0,82,82,82,4,8,112,0},{60,0,126,8,8,16,32,0},{16,16,16,24,20,16,16,0},
    {8,8,126,8,8,16,32,0},{0,60,0,0,0,0,126,0},{0,62,2,20,8,20,32,0},{8,62,4,8,28,42,8,0},{2,2,2,4,8,16,32,0},
    {16,8,68,66,66,66,66,0},{64,64,126,64,64,64,62,0},{0,126,2,2,4,8,48,0},{0,16,40,68,2,2,0,0},{8,62,8,8,42,42,8,0},
    {126,2,2,4,40,16,8,0},{0,60,0,60,0,124,2,0},{4,8,16,32,72,124,2,0},{0,2,2,20,8,20,96,0},{0,126,16,126,16,16,30,0},
    {32,32,126,34,36,32,32,0},{0,56,8,8,8,8,126,0},{126,2,2,126,2,2,126,0},{60,0,126,2,4,8,16,0},{66,66,66,66,2,4,24,0},
    {40,40,40,42,42,44,72,0},{32,32,32,34,36,40,48,0},{0,126,66,66,66,66,126,0},{0,126,66,66,2,4,24,0},{0,112,2,2,4,8,112,0},
    {16,72,32,0,0,0,0,0},{112,80,112,0,0,0,0,0},{0,0,0,62,0,0,0,0},{0,0,62,2,12,8,16,0},{0,0,4,8,24,40,8,0},
    {0,0,8,62,34,2,12,0},{0,0,0,62,8,8,62,0},{0,0,4,62,12,20,36,0},{0,0,16,62,18,20,16,0},{0,0,0,28,4,4,62,0},
    {0,0,60,4,60,4,60,0},{0,0,0,42,42,2,12,0},{0,0,0,0,0,0,0,0},{0,0,0,0,0,0,0,0},{0,0,0,0,0,0,0,0}
};

unsigned char test_moji1[16]={0,1,2,3,4,5,6,7,8,9,10,11,12,13,14,15};
unsigned char test_moji2[26]={10,11,12,13,14,15,16,17,18,19,20,21,22,23,24,25,26,27,28,29,30,31,32,33,34,35};

// delay
#define CCLK			(9600000L)
#define PBCLK		(CCLK / 2)
#define SAMPLE_RATE	5000
#define CCLK_US		(PBCLK / 100 / 1000)
#define CCLK_MS		(PBCLK / 100)

void delay_us(unsigned int  d) 
{
	unsigned int delayCount, startTime;       

	startTime = _CP0_GET_COUNT();     
	delayCount = d * CCLK_US; 
	while((_CP0_GET_COUNT() - startTime) < delayCount);  
 }

void delay_ms(unsigned int d)
{   
	unsigned int delayCount, startTime;       

	startTime = _CP0_GET_COUNT();   
	delayCount = d * CCLK_MS;   
	while((_CP0_GET_COUNT() - startTime) < delayCount);   
}

void    send_cmd(unsigned char cmd)
{
    GPIO_PinWrite(LCD_DC,0);
    GPIO_PortWrite(GPIO_PORT_D,0xff,(unsigned int)cmd);
    GPIO_PinWrite(LCD_WR,1);
    GPIO_PinWrite(LCD_WR,0);
}

void    send_data(unsigned char data)
{
    GPIO_PinWrite(LCD_DC,1);
    GPIO_PortWrite(GPIO_PORT_D,0xff,(unsigned int)data);
    GPIO_PinWrite(LCD_WR,1);
    GPIO_PinWrite(LCD_WR,0);
}

void    send_data_2(unsigned char data1,unsigned char data2)
{
    GPIO_PinWrite(LCD_DC,1);
    GPIO_PortWrite(GPIO_PORT_D,0xff,(unsigned int)data1);
    GPIO_PinWrite(LCD_WR,1);
    GPIO_PinWrite(LCD_WR,0);
    GPIO_PortWrite(GPIO_PORT_D,0xff,(unsigned int)data2);
    GPIO_PinWrite(LCD_WR,1);
    GPIO_PinWrite(LCD_WR,0);
}

void    send_data_4(unsigned char data1,unsigned char data2,unsigned char data3,unsigned char data4)
{
    GPIO_PinWrite(LCD_DC,1);
    GPIO_PortWrite(GPIO_PORT_D,0xff,(unsigned int)data1);
    GPIO_PinWrite(LCD_WR,1);
    GPIO_PinWrite(LCD_WR,0);
    GPIO_PortWrite(GPIO_PORT_D,0xff,(unsigned int)data2);
    GPIO_PinWrite(LCD_WR,1);
    GPIO_PinWrite(LCD_WR,0);
    GPIO_PortWrite(GPIO_PORT_D,0xff,(unsigned int)data3);
    GPIO_PinWrite(LCD_WR,1);
    GPIO_PinWrite(LCD_WR,0);
    GPIO_PortWrite(GPIO_PORT_D,0xff,(unsigned int)data4);
    GPIO_PinWrite(LCD_WR,1);
    GPIO_PinWrite(LCD_WR,0);
}


void    set_up(void)
{
    GPIO_PinWrite(LCD_RST,1);
    delay_us(10);
    GPIO_PinWrite(LCD_WR,0);
    delay_us(10);
    GPIO_PinWrite(LCD_RD,1);
    delay_ms(10);
    GPIO_PinWrite(LCD_CS,0);
    delay_us(10);

    send_cmd(0xc8);
    send_data(0xff);
    send_data(0x93);
    send_data(0x42);
    
    send_cmd(0x2a);
    send_data_4(0x00,0x03,0x00,0x82);
    
    send_cmd(0x2b);
    send_data_4(0x00,0x02,0x00,0x81); 

    send_cmd(0x36);
    send_data(0xa8);
    
    send_cmd(0xc0);
    send_data(0x0e);
    send_data(0x0e);

    send_cmd(0xc1);
    send_data(0x10);

    send_cmd(0xc5);
    send_data(0xfa);

    send_cmd(0x3a);
    send_data(0x55);

    send_cmd(0xb1);
    send_data(0x00);
    send_data(0x18);

    send_cmd(0xe0);
    send_data(0x00);
    send_data(0x1c);
    send_data(0x21);
    send_data(0x02);
    send_data(0x11);
    send_data(0x07);
    send_data(0x3d);
    send_data(0x79);
    send_data(0x4b);
    send_data(0x07);
    send_data(0x0f);
    send_data(0x0c);
    send_data(0x1b);
    send_data(0x1f);
    send_data(0x0f);

    send_cmd(0xe1);
    send_data(0x00);
    send_data(0x1c);
    send_data(0x20);
    send_data(0x04);
    send_data(0x0f);
    send_data(0x04);
    send_data(0x33);
    send_data(0x45);
    send_data(0x42);
    send_data(0x04);
    send_data(0x0c);
    send_data(0x0a);
    send_data(0x22);
    send_data(0x29);
    send_data(0x0f);

    send_cmd(0x11);
    delay_ms(130);

    send_cmd(0x29);
    delay_ms(100);
}

void    disp_main2(void)
{
    unsigned int    i;
    unsigned char   data1,data2;


    
            GPIO_PinWrite(GPIO_PIN_RE5,1);
            send_cmd(0x2a);
            send_data_4(0x00,0x03,0x00,0x82);
            send_cmd(0x2b);
            send_data_4(0x00,0x02,0x00,0x81);   
            send_cmd(0x2c);
    
            GPIO_PinWrite(LCD_DC,1);
    
            for (i=0;i<8192;i++){
                data1=vram[i] >> 4;
                data2=vram[i] & 0x0f;
                *(volatile uint32_t *)(&LATB + (GPIO_PORT_D * 0x40)) = color_data1[data1];
                *(volatile uint32_t *)(&LATB + (((GPIO_PORT)(LCD_WR>>4)) * 0x40)) = (*(volatile uint32_t *)(&LATB + (((GPIO_PORT)(LCD_WR>>4)) * 0x40)) & (~((uint32_t)(0x1) << (LCD_WR & 0xF)))) | (((uint32_t)(0x1) << (LCD_WR & 0xF)) & ((uint32_t)(0x01) << (LCD_WR & 0xF)));
                *(volatile uint32_t *)(&LATB + (((GPIO_PORT)(LCD_WR>>4)) * 0x40)) = (*(volatile uint32_t *)(&LATB + (((GPIO_PORT)(LCD_WR>>4)) * 0x40)) & (~((uint32_t)(0x1) << (LCD_WR & 0xF)))) | (((uint32_t)(0x1) << (LCD_WR & 0xF)) & ((uint32_t)(0x00) << (LCD_WR & 0xF)));
                *(volatile uint32_t *)(&LATB + (GPIO_PORT_D * 0x40)) = color_data2[data1];
                *(volatile uint32_t *)(&LATB + (((GPIO_PORT)(LCD_WR>>4)) * 0x40)) = (*(volatile uint32_t *)(&LATB + (((GPIO_PORT)(LCD_WR>>4)) * 0x40)) & (~((uint32_t)(0x1) << (LCD_WR & 0xF)))) | (((uint32_t)(0x1) << (LCD_WR & 0xF)) & ((uint32_t)(0x01) << (LCD_WR & 0xF)));
                *(volatile uint32_t *)(&LATB + (((GPIO_PORT)(LCD_WR>>4)) * 0x40)) = (*(volatile uint32_t *)(&LATB + (((GPIO_PORT)(LCD_WR>>4)) * 0x40)) & (~((uint32_t)(0x1) << (LCD_WR & 0xF)))) | (((uint32_t)(0x1) << (LCD_WR & 0xF)) & ((uint32_t)(0x00) << (LCD_WR & 0xF)));
                *(volatile uint32_t *)(&LATB + (GPIO_PORT_D * 0x40)) = color_data1[data2];
                *(volatile uint32_t *)(&LATB + (((GPIO_PORT)(LCD_WR>>4)) * 0x40)) = (*(volatile uint32_t *)(&LATB + (((GPIO_PORT)(LCD_WR>>4)) * 0x40)) & (~((uint32_t)(0x1) << (LCD_WR & 0xF)))) | (((uint32_t)(0x1) << (LCD_WR & 0xF)) & ((uint32_t)(0x01) << (LCD_WR & 0xF)));
                *(volatile uint32_t *)(&LATB + (((GPIO_PORT)(LCD_WR>>4)) * 0x40)) = (*(volatile uint32_t *)(&LATB + (((GPIO_PORT)(LCD_WR>>4)) * 0x40)) & (~((uint32_t)(0x1) << (LCD_WR & 0xF)))) | (((uint32_t)(0x1) << (LCD_WR & 0xF)) & ((uint32_t)(0x00) << (LCD_WR & 0xF)));
                *(volatile uint32_t *)(&LATB + (GPIO_PORT_D * 0x40)) = color_data2[data2];
                *(volatile uint32_t *)(&LATB + (((GPIO_PORT)(LCD_WR>>4)) * 0x40)) = (*(volatile uint32_t *)(&LATB + (((GPIO_PORT)(LCD_WR>>4)) * 0x40)) & (~((uint32_t)(0x1) << (LCD_WR & 0xF)))) | (((uint32_t)(0x1) << (LCD_WR & 0xF)) & ((uint32_t)(0x01) << (LCD_WR & 0xF)));
                *(volatile uint32_t *)(&LATB + (((GPIO_PORT)(LCD_WR>>4)) * 0x40)) = (*(volatile uint32_t *)(&LATB + (((GPIO_PORT)(LCD_WR>>4)) * 0x40)) & (~((uint32_t)(0x1) << (LCD_WR & 0xF)))) | (((uint32_t)(0x1) << (LCD_WR & 0xF)) & ((uint32_t)(0x00) << (LCD_WR & 0xF)));
            }
            GPIO_PinWrite(GPIO_PIN_RE5,0);                

}
void    test_vram(void)
{
    unsigned int    i;
    
    for(i=0;i<8192/2;i++){
        vram[i*2]=0x13;
        vram[i*2+1]=0x45;
    }
}

void    vram_clear(unsigned char color)
{
    unsigned int i;
    unsigned char data;
    
    data=(color << 4) | color;
    
    for(i=0;i<8192;i++){
        vram[i]=data;
    }
}

void    vram_set_moji(unsigned int xx,unsigned int yy,unsigned int nn,unsigned char *moji,unsigned char f_color,unsigned char b_color)
{
    unsigned char   data,i,j;
    unsigned int    pointa;
    unsigned char   v_data[4];
    
    for(j=0;j<nn;j++){
        for(i=0;i<8;i++){
            data=game_moji_font[moji[j]][i];
            if((data & 0x80)==0x80){
                v_data[0]=f_color << 4;
            }
            else{
                v_data[0]=b_color << 4;
            }
            data=data << 1;
            if((data & 0x80)==0x80){
                v_data[0]=v_data[0] | f_color;
            }
            else{
                v_data[0]=v_data[0] | b_color;
            }
            data=data << 1;

            if((data & 0x80)==0x80){
                v_data[1]=f_color << 4;
            }
            else{
                v_data[1]=b_color << 4;
            }
            data=data << 1;
            if((data & 0x80)==0x80){
                v_data[1]=v_data[1] | f_color;
            }
            else{
                v_data[1]=v_data[1] | b_color;
            }
            data=data << 1;            

            if((data & 0x80)==0x80){
                v_data[2]=f_color << 4;
            }
            else{
                v_data[2]=b_color << 4;
            }
            data=data << 1;
            if((data & 0x80)==0x80){
                v_data[2]=v_data[2] | f_color;
            }
            else{
                v_data[2]=v_data[2] | b_color;
            }
            data=data << 1;

            if((data & 0x80)==0x80){
                v_data[3]=f_color << 4;
            }
            else{
                v_data[3]=b_color << 4;
            }
            data=data << 1;
            if((data & 0x80)==0x80){
                v_data[3]=v_data[3] | f_color;
            }
            else{
                v_data[3]=v_data[3] | b_color;
            }
            
            pointa=(xx+j)*4+(yy*8+i)*64;
            vram[pointa]=v_data[0];
            vram[pointa+1]=v_data[1];
            vram[pointa+2]=v_data[2];
            vram[pointa+3]=v_data[3];
        }
    }
}

void    vram_test_moji(void)
{
    vram_set_moji(0,0,16,test_moji1,1,0);
    vram_set_moji(0,1,16,test_moji1,2,0);
    vram_set_moji(0,2,16,test_moji1,3,0);
    vram_set_moji(0,3,16,test_moji1,4,0);
    vram_set_moji(0,4,16,test_moji1,5,0);
    vram_set_moji(0,5,16,test_moji1,6,0);
    vram_set_moji(0,6,16,test_moji1,7,0);
    vram_set_moji(0,7,16,test_moji1,8,0);
    vram_set_moji(0,8,16,test_moji1,9,0);
    vram_set_moji(0,9,16,test_moji1,10,0);
    vram_set_moji(0,10,16,test_moji1,11,0);
    vram_set_moji(0,11,16,test_moji1,12,0);
    vram_set_moji(0,12,16,test_moji1,13,0);
    vram_set_moji(0,13,16,test_moji1,14,0);
    vram_set_moji(0,14,16,test_moji1,15,0);
    vram_set_moji(0,15,16,test_moji1,1,0); 
}





// *****************************************************************************
// *****************************************************************************
int main ( void )
{


    
    /* Initialize all modules */
    SYS_Initialize ( NULL );

    
 
    set_up();

    //test_vram();
    vram_clear(0);
    vram_test_moji();
    disp_main2();
    

    
    while ( true )
    {
        /* Maintain state machines of all polled MPLAB Harmony modules. */
        //SYS_Tasks ( );
        

      
        /* Execution should not come here during normal operation */
    }
    //return ( EXIT_FAILURE );
}


/*******************************************************************************
 End of File
*/

